package com.simonstl.ents;

import java.util.*;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>This class stores a set of rules, making it easy to define rule sets separately from the vocabulary defined for the examples.</p>
*
* @version 0.01 4 February 2002
* @author Simon St.Laurent
*/

public class EntRules {

protected HashMap rulesByEnt=new HashMap();
protected HashMap rulesByRef=new HashMap();

public EntRules(){
}

public void addRule(EntRule rule){
  rulesByEnt.put(rule.getEnt(),rule);
  rulesByRef.put(rule.getRef(),rule);

}

/**Returns the numeric reference equivalent to a particular entity name.**/

public String resultEntRule(String match) {
  String returnVal=null;
  EntRule rule=(EntRule) rulesByEnt.get(match);

  if (rule!=null) { returnVal=rule.getRef();}

  return returnVal;
}


/**Returns the entity name equivalent to a particular numeric reference .**/

public String resultRefRule(String match) {
  String returnVal=null;
  EntRule rule=(EntRule) rulesByRef.get(match);

  if (rule!=null) { returnVal=rule.getEnt();}

  return returnVal;
}



/**
prints the lists of rules
*/

public void print(){
System.out.println(toString());
}

/**
* lists both sets of rules
*/

public String toString(){
Iterator it;

String value="By Ref:\n";

it=rulesByRef.values().iterator();

while (it.hasNext()) {
   EntRule rule=(EntRule) it.next();
   value=value+"Ref: "+rule.getRef()+"="+rule.getEnt()+"\n";
}

value=value+"By Ent:\n";
it=rulesByEnt.values().iterator();
while (it.hasNext()) {
   EntRule rule=(EntRule) it.next();
   value=value+"Ent: "+rule.getEnt()+"="+rule.getRef()+"\n";
}

return value;
}

}