package com.simonstl.ents;

import com.simonstl.namespace.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.IOException;
import java.util.*;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>This class loads the information stored in a rules document for use in character entity/character reference replacement.  It's based on Ethan Cerami's Xerces Quickstart, available at:</p>
* <p><a href="http://ecerami.com/xerces/" target="_top">http://ecerami.com/xerces/</a></p>
*
*
* @version 0.01 4 February 2002
* @author Simon St.Laurent
*/

public class EntRulesLoader extends DefaultHandler {
    
    public EntRules rules;   //set of rules

    // Constructor
    public EntRulesLoader (String xmlFile, XMLReader parser) {
        
        //  Set Content Handler
        parser.setContentHandler (this);

        // Create a rules container
        rules=new EntRules();

 
        //  Parse the Document      
        try {
            parser.parse(xmlFile);
        } catch (SAXException e) {
            System.err.println (e);
        } catch (IOException e) {
            System.err.println (e);
        }
    }
    
    //  Start Element Event Handler
public void startElement (String uri, String local,
        String qName, Attributes atts)  {

       
        if (uri.equals("http://simonstl.com/ns/refsEnts/")) {
//System.out.println(qName);
           if (local.equals("equal")) {
             String ref=atts.getValue("ref");
             String ent=atts.getValue("ent");
             EntRule rule=new EntRule(ent, ref);
             rules.addRule(rule);
           }
       }//end namespace
}//end startElement


   
}